// InfoTree.cpp : implementation file
//

#include "stdafx.h"
#include "InfoTree.h"

// CInfoTree

IMPLEMENT_DYNAMIC(CInfoTree, CTreeCtrl)
CInfoTree::CInfoTree()
{
}

CInfoTree::~CInfoTree()
{
}


BEGIN_MESSAGE_MAP(CInfoTree, CTreeCtrl)
    ON_WM_MOUSEMOVE()
    ON_MESSAGE(WM_MOUSELEAVE, OnMouseLeave)
END_MESSAGE_MAP()



// CInfoTree message handlers

/****************************************************************************
*                             CInfoTree::FindItem
* Inputs:
*       HTREEITEM item: root of tree or subtree
*       CPoint point: Point to locate
* Result: HTREEITEM
*       The actual tree item specified by point, or NULL if not found
****************************************************************************/

HTREEITEM CInfoTree::FindItem(HTREEITEM item, CPoint point)
    {
     CRect r;
     if(!GetItemRect(item, &r, TRUE))
        return NULL;
     if(r.PtInRect(point))
        return item;

     HTREEITEM child = GetChildItem(item);
     if(child != NULL)
        { /* has children */
         HTREEITEM p = FindItem(child, point);
         if(p != NULL)
            return p;
        } /* has children */

     HTREEITEM sib = GetNextSiblingItem(item);
     if(sib != NULL)
        { /* has siblings */
         HTREEITEM p = FindItem(sib, point);
         if(p != NULL)
            return p;
        } /* has siblings */
     return NULL;
    } // CInfoTree::FindItem


/****************************************************************************
*                           CInfoTree::OnMouseMove
* Inputs:
*       UINT nFlags:
*       CPoint point:
* Result: void
*       
* Effect: 
*       Pops up help for the item
****************************************************************************/

void CInfoTree::OnMouseMove(UINT nFlags, CPoint point)
    {
     HTREEITEM item = FindItem(GetRootItem(), point);
     GetParent()->SendMessage(UWM_INFOTREE_TEXT, (WPARAM)item);
     CTreeCtrl::OnMouseMove(nFlags, point);
    }

/****************************************************************************
*                           CInfoTree::OnMouseLeave
* Inputs:
*       WPARAM: ignored
*       LPARAM: ignored
* Result: LRESULT
*       Logically void, 0, always
* Effect: 
*       Handles the mouse leaving the window
****************************************************************************/

LRESULT CInfoTree::OnMouseLeave(WPARAM, LPARAM)
    {
     GetParent()->SendMessage(UWM_INFOTREE_TEXT, (WPARAM)NULL);
     return 0;
    } // CInfoTree::OnMouseLeave
