// classmapDlg.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "classmapDlg.h"
#include "RegVars.h"
#include "InfoTree.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
        CAboutDlg();

// Dialog Data
        enum { IDD = IDD_ABOUTBOX };

        protected:
        virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
        DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
        CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CclassmapDlg dialog



CclassmapDlg::CclassmapDlg(CWnd* pParent /*=NULL*/)
        : CDialog(CclassmapDlg::IDD, pParent)
{
        m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
        c_Info = NULL;
}

void CclassmapDlg::DoDataExchange(CDataExchange* pDX)
{
CDialog::DoDataExchange(pDX);
DDX_Control(pDX, IDC_TREE, c_Tree);
DDX_Control(pDX, IDC_FOLDER, c_Folder);
DDX_Control(pDX, IDC_BROWSE, c_Browse);
DDX_Control(pDX, IDC_LOG, c_Log);
DDX_Control(pDX, IDC_GO, c_Go);
DDX_Control(pDX, IDC_MFC_PATH, c_MFCPath);
DDX_Control(pDX, IDC_MFC, c_UseMFC);
DDX_Control(pDX, IDC_BROWSE_MFC, c_BrowseMFC);
DDX_Control(pDX, IDC_STATUS, c_Status);
DDX_Control(pDX, IDC_EXPANDALL, c_ExpandAll);
DDX_Control(pDX, IDC_COLLAPSEALL, c_CollapseAll);
}

BEGIN_MESSAGE_MAP(CclassmapDlg, CDialog)
        ON_WM_SYSCOMMAND()
        ON_WM_PAINT()
        ON_WM_QUERYDRAGICON()
        //}}AFX_MSG_MAP
        ON_WM_CLOSE()
        ON_WM_SIZE()
        ON_BN_CLICKED(IDC_BROWSE, OnBnClickedBrowse)
        ON_BN_CLICKED(IDC_GO, OnBnClickedGo)
        ON_EN_CHANGE(IDC_FOLDER, OnEnChangeFolder)
        ON_BN_CLICKED(IDC_BROWSE_MFC, OnBnClickedBrowseMfc)
        ON_BN_CLICKED(IDC_MFC, OnBnClickedMfc)
        ON_BN_CLICKED(IDC_EXPANDALL, OnBnClickedExpandall)
        ON_BN_CLICKED(IDC_COLLAPSEALL, OnBnClickedCollapseall)
        ON_COMMAND(ID_HELP_ABOUT, OnHelpAbout)
        ON_COMMAND(ID_VIEW_EXPANDALL, OnViewExpandall)
        ON_COMMAND(ID_VIEW_COLLAPSEALL, OnViewCollapseall)
        ON_COMMAND(ID_FILE_EXIT, OnFileExit)
        ON_COMMAND(ID_FILE_WRITETEXTFILE, OnFileWritetextfile)
        ON_COMMAND(ID_FILE_WRITEGRAPHICALMETAFILE, OnFileWriteGraphicalMetafile)
        ON_COMMAND(ID_VIEW_FONT, OnViewFont)
        ON_WM_INITMENUPOPUP()
        ON_NOTIFY(TVN_ITEMEXPANDED, IDC_TREE, OnTvnItemexpandedTree)
        ON_WM_DESTROY()
        ON_REGISTERED_MESSAGE(UWM_INFOTREE_TEXT, OnInfoTreeText)
        ON_COMMAND(ID_FILE_PRINT, OnFilePrint)
END_MESSAGE_MAP()


// CclassmapDlg message handlers

BOOL CclassmapDlg::OnInitDialog()
{
        CDialog::OnInitDialog();

        // Add "About..." menu item to system menu.

        // IDM_ABOUTBOX must be in the system command range.
        ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
        ASSERT(IDM_ABOUTBOX < 0xF000);

        CMenu* pSysMenu = GetSystemMenu(FALSE);
        if (pSysMenu != NULL)
        {
                CString strAboutMenu;
                strAboutMenu.LoadString(IDS_ABOUTBOX);
                if (!strAboutMenu.IsEmpty())
                {
                        pSysMenu->AppendMenu(MF_SEPARATOR);
                        pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
                }
        }

        // Set the icon for this dialog.  The framework does this automatically
        //  when the application's main window is not a dialog
        SetIcon(m_hIcon, TRUE);                 // Set big icon
        SetIcon(m_hIcon, FALSE);                // Set small icon

        // TODO: Add extra initialization here
        
        RegistryString folder(IDS_REGISTRY_FOLDER);
        folder.load();
        c_Folder.SetWindowText(folder.value);
        
        RegistryString mfcpath(IDS_REGISTRY_MFC_PATH);
        mfcpath.load();
        c_MFCPath.SetWindowText(mfcpath.value);

        RegistryInt mfc(IDS_REGISTRY_MFC);
        mfc.load();
        c_UseMFC.SetCheck(mfc.value ? BST_CHECKED : BST_UNCHECKED);
        c_Status.SetWindowText(_T(""));
        updateControls();
        return TRUE;  // return TRUE  unless you set the focus to a control
}

void CclassmapDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
        if ((nID & 0xFFF0) == IDM_ABOUTBOX)
        {
         CAboutDlg dlgAbout;
         dlgAbout.DoModal();
        }
        else
        {
                CDialog::OnSysCommand(nID, lParam);
        }
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CclassmapDlg::OnPaint() 
{
        if (IsIconic())
        {
                CPaintDC dc(this); // device context for painting

                SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

                // Center icon in client rectangle
                int cxIcon = GetSystemMetrics(SM_CXICON);
                int cyIcon = GetSystemMetrics(SM_CYICON);
                CRect rect;
                GetClientRect(&rect);
                int x = (rect.Width() - cxIcon + 1) / 2;
                int y = (rect.Height() - cyIcon + 1) / 2;

                // Draw the icon
                dc.DrawIcon(x, y, m_hIcon);
        }
        else
        {
                CDialog::OnPaint();
        }
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CclassmapDlg::OnQueryDragIcon()
{
        return static_cast<HCURSOR>(m_hIcon);
}

/****************************************************************************
*                           CclassmapDlg::OnCancel
* Result: void
*       
* Effect: 
*       Does nothing.  Keeps the app from being closed by <esc>
****************************************************************************/

void CclassmapDlg::OnCancel()
    {
    }

/****************************************************************************
*                             CclassmapDlg::OnOK
* Result: void
*       
* Effect: 
*       Does nothing.  Keeps the app from being closed by <enter>
****************************************************************************/

void CclassmapDlg::OnOK()
    {
    }

/****************************************************************************
*                            CclassmapDlg::OnClose
* Result: void
*       
* Effect: 
*       Closes the app
****************************************************************************/

void CclassmapDlg::OnClose()
    {
     CDialog::OnOK();
    }

/****************************************************************************
*                            CclassmapDlg::OnSize
* Inputs:
*       UINT nTYpe:
*       int cx:
*       int cy:
* Result: void
*       
* Effect: 
*       Resizes the controls
****************************************************************************/

void CclassmapDlg::OnSize(UINT nType, int cx, int cy)
    {
     CDialog::OnSize(nType, cx, cy);

     if(c_Tree.GetSafeHwnd() != NULL)
        { /* expand tree */
         CRect r;
         c_Tree.GetWindowRect(&r);
         ScreenToClient(&r);
         c_Tree.SetWindowPos(NULL, 0, 0,
                             cx - r.left,
                             cy - r.top,
                             SWP_NOMOVE | SWP_NOZORDER);
        } /* expand tree */

     if(c_Log.GetSafeHwnd() != NULL)
        { /* expand log */
         CRect r;
         c_Log.GetWindowRect(&r);
         ScreenToClient(&r);
         c_Log.SetWindowPos(NULL, 0, 0, // no change z-order, position
                            cx - r.left,
                            r.Height(),
                            SWP_NOZORDER | SWP_NOMOVE);
        } /* expand log */
    }

/****************************************************************************
*                       CclassmapDlg::OnBnClickedBrowse
* Result: void
*       
* Effect: 
*       SHBrowseForFolder dialog
****************************************************************************/

void CclassmapDlg::OnBnClickedBrowse()
    {
     CString s;
     if(BrowseForFolder(s))
        c_Folder.SetWindowText(s);
    }

/****************************************************************************
*                            CclassmapDlg::Extract
* Inputs:
*       CString line: Input line
*       CString & parent: Parent name defined
*       CString & classname: Class name defined
* Result: BOOL
*       TRUE if found
*       FALSE if not
* Effect: 
*       Extracts the two elements from an IMPLEMENT_ call
****************************************************************************/

BOOL CclassmapDlg::Extract(const CString & filename, int lineno, CString line, CString & parent, CString & classname)
    {
     CString input = line;

     static LPCTSTR creates[] = {
        _T("IMPLEMENT_DYNAMIC"),
        _T("IMPLEMENT_DYNCREATE"),
        _T("IMPLEMENT_SERIAL"),
        NULL };

     line.Trim();
     // Quick filter
     if(line[0] != _T('I'))
        return FALSE;
     
     for(int i = 0; creates[i] != NULL; i++)
        { /* see if right kind */
         int len = (int)_tcslen(creates[i]);
         if(_tcsncmp(line, creates[i], len) == 0)
            { /* have one */
             TRACE(">>>%s\n", line);
             // IMPLEMENT_XXXXXX( *class *, *parent *)
             line = line.Mid(len);
             line.Trim();
             if(line[0] != _T('('))
                { /* bad synax */
                 c_Log.AddString(new TraceFormatError(TraceEvent::None, IDS_MISSING_OPEN_PAREN, filename, lineno, input));
                 return FALSE;
                } /* bad synax */

             line = line.Mid(1);
             line.Trim();
             int n = line.Find(_T(","));
             if(n < 0)
                { /* missing comma */
                 c_Log.AddString(new TraceFormatError(TraceEvent::None, IDS_MISSING_COMMA, filename, lineno, input));
                 return FALSE;
                } /* missing comma */

             classname = line.Left(n);
             classname.Trim();
             line = line.Mid(n + 1);
             line.Trim();
             // If we are IMPLEMENT_SERIAL, there is a , at the end
             n = line.Find(_T(","));
             if(n < 0)
                n = line.Find(_T(")"));

             if(n < 0)
                { /* missing ) or , */
                 c_Log.AddString(new TraceFormatError(TraceEvent::None, IDS_MISSING_CLOSE_PAREN_OR_COMMA, filename, lineno, input));
                 return FALSE;
                } /* missing ) or , */
             parent = line.Left(n);
             parent.Trim();
             TRACE("%s --> %s\n", parent, classname);
             return TRUE;
            } /* have one */
        } /* see if right kind */
     return FALSE;
    } // CclassmapDlg::Extract

/****************************************************************************
*                           CclassmapDlg::ScanFile
* Inputs:
*       const CString & name: File name to scan
*       BOOL initial: Selective scan option
* Result: void
*       
* Effect: 
*       Scans the file looking for IMPLEMENT_DYNAMIC, IMPLEMENT_DYNCREATE and
*       IMPLEMENT_SERIAL
****************************************************************************/

void CclassmapDlg::ScanFile(const CString & name, BOOL initial)
    {
     CStdioFile f;
     c_Status.SetWindowText(name);
     if(!f.Open(name, CFile::modeRead))
        { /* failed */
         DWORD err = ::GetLastError();
         c_Log.AddString(new TraceFormatError(TraceEvent::None, IDS_FILE_OPEN_FAILED, name));
         c_Log.AddString(new TraceFormatMessage(TraceEvent::None, err));
         return;
        } /* failed */

     int lineno = 0;
     CString line;
     while(f.ReadString(line))
        { /* scan line */
         lineno++;
         CString parent;
         CString classname;

         if(!Extract(name, lineno, line, parent, classname))
            continue;

         element * e = elements.lookup(classname);
         if(e != NULL)
            { /* already entered */
             if(!e->file.IsEmpty())
                { /* two defs */
                 c_Log.AddString(new TraceFormatError(TraceEvent::None, IDS_DUPLICATE_DEFINITION, name, lineno, classname, e->file, e->line));
                 continue;
                } /* two defs */
             // we had a forward reference, fix it up, below
            } /* already entered */
         else
            { /* not entered */
             e = elements.enter(classname);
            } /* not entered */

         e->file = name;
         e->line = lineno;
         e->initial = initial;
         
         element * p = elements.lookup(parent);
         if(p == NULL)
            p = elements.enter(parent);

         e->parent = p;

         if(p->child == NULL)
            { /* first child */
             p->child = e;
             /******************************************
               case A: child is NULL
               p:
                   +--------+
               +-->|        |
               |   +--------+
               |   | child  |
               |   +---+----+
               |       |                               
               |       |
               |   e:  V
               |   +--------+
               +---+ parent |
                   +--------+
             *****************************************/
             continue;
            } /* first child */

         if(e->classname < p->child->classname)
            { /* splice to front */
             /******************************************
                       case B: new element is lower than p->child
                       p:
                       +--------+
                   +-->|        |<-+
                   |   +--------+  |
                   |   | child  |  |
                   |   +---+----+  |
                   |       |       |                        
                   |       |       |
                   |   e:  V       |   p->child: (at start)
                   |   +--------+  |  +--------+
                   +---+ parent |  +--+ parent |
                       +--------+     +--------+
                       |  next  +---->|  next  +...
                       +--------+     +--------+
                       |  prev  |<----+  prev  |
                       +--------+     +--------+
             *****************************************/
             e->next = p->child;
             p->child->prev = e;
             p->child = e;
             continue;
            } /* splice to front */

         for(element * sib = p->child; ; sib = sib->next)
            { /* insert sorted */
             if(sib->next == NULL)
                { /* insert at end */
                 /****************************************************************
                   case C: new element is higher than any already in list
                           p:
                           +--------+
                       +-->|        |<-+
                       |   +--------+  |
                       |   | child  |  |
                       |   +---+----+  |
                       |       |       |                        
                       |       |       |
                       |       V       |   sib
                       |   +--------+  |  +--------+
                       +---+ parent |  +--+ parent |
                           +--------+     +--------+
                           |  next  +---->|  next  +-->//
                           +--------+     +--------+
                           |  prev  |<----+  prev  |
                           +--------+     +--------+
                       *******
                       becomes
                       *******
                           case C resolution: append to end of list
                           p:
                           +--------+
                       +-->|        |<-+
                       |   +--------+  |
                       |   | child  |  |
                       |   +---+----+  |
                       |       |       |                        
                       |       |       |
                       |       V       |   sib:           e:
                       |   +--------+  |  +--------+     +--------+
                       +---+ parent |  +--+ parent |     |        |
                           +--------+     +--------+     +--------+
                           |  next  +---->|  next  +---->|  next  +--->//
                           +--------+     +--------+     +--------+
                           |  prev  |<----+  prev  |<----+  prev  |
                           +--------+     +--------+     +--------+

                     ****************************************************************/
                 
                 sib->next = e;
                 e->prev = sib;
                 break; /* insert sorted */
                } /* insert at end */

             if(e->classname < sib->next->classname)
                { /* insert here */
                 e->next = sib->next;
                 e->prev = sib;
                 e->prev->next = e;
                 e->next->prev = e;
                 break; /* insert sorted */
                } /* insert here */
            } /* insert sorted */
        } /* scan line */
     f.Close();
    } // CclassmapDlg::ScanFile

/****************************************************************************
*                           CclassmapDlg::ScanFiles
* Inputs:
*       const CString & pattern: Pattern to use
* Result: BOOL
*       
* Effect: 
*       Scans all the files in the directory
****************************************************************************/

BOOL CclassmapDlg::ScanFiles(const CString & pattern, BOOL initial)
    {
     CFileFind finder;

     BOOL bWorking = finder.FindFile(pattern);
     if(!bWorking)
        return FALSE;

     while (bWorking)
        {
         bWorking = finder.FindNextFile();
         ScanFile(finder.GetFilePath(), initial);
        }
     
     c_Status.SetWindowText(_T(""));
     elements.Dump();
     return TRUE;
    } // CclassmapDlg::ScanFiles

/****************************************************************************
*                           CclassmapDlg::propagate
* Inputs:
*       element * e: Element to propagate upwards
* Result: void
*       
* Effect: 
*       Propagates the initial value upwards to the parent
****************************************************************************/

void CclassmapDlg::propagate(element * e)
    {
     if(!e->initial)
        return;
     while(e->parent != NULL)
        { /* scan */
         e = e->parent;
         e->selected = TRUE;
        } /* scan */
    } // CclassmapDlg::propagate

/****************************************************************************
*                         CclassmapDlg::OnBnClickedGo
* Result: void
*       
* Effect: 
*       Does the analysis
****************************************************************************/

void CclassmapDlg::OnBnClickedGo()
    {
     c_Go.EnableWindow(FALSE);
     CWaitCursor wait;
     CString s;
     c_Folder.GetWindowText(s);
     s.Trim();

     CString basedir;
     basedir = s;
     if(basedir.Right(1) != _T("\\"))
        basedir += _T("\\");
     CString pattern;
     pattern = basedir + _T("*.cpp");

     elements.clear();
     c_Tree.DeleteAllItems();
     
     if(!ScanFiles(pattern, TRUE))
        { /* report error */
         DWORD err = ::GetLastError();
         c_Log.AddString(new TraceFormatError(TraceEvent::None, IDS_NO_FILES_FOUND, pattern));
         c_Log.AddString(new TraceFormatMessage(TraceEvent::None, err));
         c_Go.EnableWindow(TRUE);
         return;
        } /* report error */

     RegistryString folder(IDS_REGISTRY_FOLDER);
     folder.value = basedir;
     folder.store();

     if(c_UseMFC.GetCheck() == BST_CHECKED)
        { /* scan MFC */
         c_MFCPath.GetWindowText(pattern);
         pattern.Trim();
         if(pattern.Right(1) != _T("\\"))
            pattern += _T("\\");
         pattern += _T("*.cpp");
         ScanFiles(pattern, FALSE);
        } /* scan MFC */

     elements.sort();

     /****************************************************************
       This code picks up each node, and if the node is marked as a
       'selective' node, propagates the 'initial' property upwards
       via the 'selected' property.
     ****************************************************************/

     POSITION p = elements.GetFirstPosition();
     while(p != NULL)
        { /* propagate */
         element * e = elements.GetNext(p);
         if(e->selected)
            continue; // already processed this via another path
         if(!e->initial)
            continue; // not an initial node
         propagate(e);
        } /* propagate */

     p = elements.GetFirstPosition();
     while(p != NULL)
        { /* scan each */
         element * e = elements.GetNext(p);
         if(e->parent == NULL)
            { /* root element */
             ShowTree(e, TVI_ROOT, 0);
            } /* root element */
        } /* scan each */
     c_Go.EnableWindow(TRUE);
     updateControls();
    }

/****************************************************************************
*                           CclassmapDlg::ShowTree
* Inputs:
*       element * e: Element
*       HTREEITEM item
* Result: void
*       
* Effect: 
*       Inserts element and all subelements in tree
****************************************************************************/

void CclassmapDlg::ShowTree(element * e, HTREEITEM item, int depth)
    {
     TRACE("%sShowTree: %p:%s%s %s, %p\n", 
            CString(_T(' '), depth * 2),
            e,  
            e->initial ? _T("+") : _T(""), 
            e->selected ? _T("*") : _T(""), 
            e->classname, 
            item);

     HTREEITEM parent = NULL;

     if(!(e->initial || e->selected))
        return;

     CString s;
     s = e->classname;

#ifdef _DEBUG
     if(e->initial)
        s += _T("+");
     if(e->selected)
        s += _T("*");
#endif     
     parent = c_Tree.InsertItem(s, item);
     CString location;
     c_Tree.SetItemData(parent, (DWORD_PTR)e);

     for(element * child = e->child; child != NULL; child = child->next)
        ShowTree(child, parent, depth + 1);
    } // CclassmapDlg::ShowTree

/****************************************************************************
*                        CclassmapDlg::updateControls
* Result: void
*       
* Effect: 
*       Updates the controls
****************************************************************************/

void CclassmapDlg::updateControls()
    {
     CString s;
     c_Folder.GetWindowText(s);
     s.Trim();
     c_Go.EnableWindow(s.IsEmpty() ? FALSE : TRUE);
                       
     BOOL enable = c_UseMFC.GetCheck() == BST_CHECKED;
     c_MFCPath.EnableWindow(enable);
     c_BrowseMFC.EnableWindow(enable);

     c_ExpandAll.EnableWindow(!AreAllExpanded(c_Tree.GetRootItem()));
     c_CollapseAll.EnableWindow(!AreAllCollapsed(c_Tree.GetRootItem()));
    } // CclassmapDlg::updateControls

/****************************************************************************
*                       CclassmapDlg::OnEnChangeFolder
* Result: void
*       
* Effect: 
*       Update the controls
****************************************************************************/

void CclassmapDlg::OnEnChangeFolder()
    {
     updateControls();
    }

/****************************************************************************
*                     CclassmapDlg::OnBnClickedBrowseMfc
* Result: void
*       
* Effect: 
*       Selects the MFC directory
****************************************************************************/

void CclassmapDlg::OnBnClickedBrowseMfc()
    {
     CString s;
     if(BrowseForFolder(s))
        { /* got it */
         c_MFCPath.SetWindowText(s);
         RegistryString mfcpath(IDS_REGISTRY_MFC_PATH);
         mfcpath.value = s;
         mfcpath.store();
        } /* got it */
    }

/****************************************************************************
*                        CclassmapDlg::OnBnClickedMfc
* Result: void
*       
* Effect: 
*       Updates the controls
****************************************************************************/

void CclassmapDlg::OnBnClickedMfc()
    {
     updateControls();
     RegistryInt mfc(IDS_REGISTRY_MFC);
     mfc.value = c_UseMFC.GetCheck() == BST_CHECKED;
     mfc.store();
    }

/****************************************************************************
*                        CclassmapDlg::BrowseForFolder
* Inputs:
*       CString & folder: Result folder
* Result: BOOL
*       TRUE if successful
*       FALSE if error
* Effect: 
*       Browses for a folder
****************************************************************************/

BOOL CclassmapDlg::BrowseForFolder(CString & s)
    {
     BROWSEINFO info;
     info.hwndOwner = m_hWnd;
     info.pidlRoot = NULL;
      info.pszDisplayName = NULL;
     info.lpszTitle = NULL; // ignore for now
     info.ulFlags = BIF_EDITBOX | BIF_NEWDIALOGSTYLE;
     info.lpfn = NULL;
     info.lParam = 0;
     info.iImage = 0;
     LPITEMIDLIST id = SHBrowseForFolder(&info);
     if(id == NULL)
        return FALSE;

     LPTSTR p = s.GetBuffer(MAX_PATH);
     BOOL result = SHGetPathFromIDList(id, p);
     s.ReleaseBuffer();
     return result;
    } // CclassmapDlg::BrowseForFolder

/****************************************************************************
*                     CclassmapDlg::OnBnClickedExpandAll
*                     CclassmapDlg::OnBnClickedCollapseAll
* Result: void
*       
* Effect: 
*       Expand or collapse the entire tree
****************************************************************************/

void CclassmapDlg::OnBnClickedExpandall()
    {
     HTREEITEM item = c_Tree.GetRootItem();
     DoExpand(item, TVE_EXPAND);
     updateControls();
    }

void CclassmapDlg::OnBnClickedCollapseall()
    {
     HTREEITEM item = c_Tree.GetRootItem();
     DoExpand(item, TVE_COLLAPSE);
     updateControls();
    }

/****************************************************************************
*                           CclassmapDlg::DoExpand
* Inputs:
*       HTREEITEM item: Item to expand or collapse
*       UINT type: Type TVE_EXPAND or TVE_COLLAPSE
* Result: void
*       
* Effect: 
*       Expands or collapses the entire tree
****************************************************************************/

void CclassmapDlg::DoExpand(HTREEITEM item, UINT type, UINT depth)
    {
     //TRACE("%s%p: %s\n", CString(_T(' '), depth * 2), item, c_Tree.GetItemText(item));

     c_Tree.Expand(item, type);

     HTREEITEM child = c_Tree.GetChildItem(item);
     if(child != NULL)
        DoExpand(child, type, depth + 1);

     HTREEITEM sib = c_Tree.GetNextSiblingItem(item);
     if(sib != NULL)
        DoExpand(sib, type, depth);
    } // CclassmapDlg::DoExpand

/****************************************************************************
*                           CclassmapDlg::WriteTree
* Inputs:
*       CStdioFile & f: File to write to
*       HTREEITEM item: Item
* Result: void
*       
* Effect: 
*       Writes the tree node out
****************************************************************************/

void CclassmapDlg::WriteTree(CStdioFile & f, HTREEITEM item)
    {
     CString line;
     IndentIt(f, item);
     if(c_Tree.GetRootItem() != item)
        { /* follow line */
         line = _T("|\n");
         f.WriteString(line);
         TRACE(line);
         IndentIt(f, item);
        } /* follow line */

     line.Format(_T("+--%s\n"), c_Tree.GetItemText(item));
     f.WriteString(line);
     TRACE(line);
     
     HTREEITEM child = c_Tree.GetChildItem(item);
     if(child != NULL)
        { /* write children */
         WriteTree(f, child);
        } /* write children */
     
     HTREEITEM sib = c_Tree.GetNextSiblingItem(item);
     if(sib != NULL)
        WriteTree(f, sib);
    } // CclassmapDlg::WriteTree

/****************************************************************************
*                           CclassmapDlg::IndentIt
* Inputs:
*       CStdioFile & f: File to write to
*       HTREEITEM item: Item to indent
* Result: void
*       
* Effect: 
*       Displays an indentation
****************************************************************************/

void CclassmapDlg::IndentIt(CStdioFile & f, HTREEITEM item)
    {
     HTREEITEM parent = c_Tree.GetParentItem(item);
     if(parent == NULL)
        return; // fully indented
     IndentIt(f, parent);
     CString line;
     if(c_Tree.GetNextSiblingItem(parent) != NULL)
        line =_T("|  "); 
     else
        line = _T("   ");
     TRACE(line);
     f.WriteString(line);
    } // CclassmapDlg::IndentIt

/****************************************************************************
*                          CclassmapDlg::OnHelpAbout
* Result: void
*       
* Effect: 
*       About dialog
****************************************************************************/

void CclassmapDlg::OnHelpAbout()
    {
     CAboutDlg dlgAbout;
     dlgAbout.DoModal();
    }

/****************************************************************************
*                        CclassmapDlg::OnViewExpandAll
* Result: void
*       
* Effect: 
*       Expands/collapses the entire tree
****************************************************************************/

void CclassmapDlg::OnViewExpandall()
    {
     OnBnClickedExpandall();
    }

void CclassmapDlg::OnViewCollapseall()
    {
     OnBnClickedCollapseall();
    }

/****************************************************************************
*                          CclassmapDlg::OnFileExit
* Result: void
*       
* Effect: 
*       Closes the app
****************************************************************************/

void CclassmapDlg::OnFileExit()
    {
     CDialog::OnOK();
    }

/****************************************************************************
*                      CclassmapDlg::OnFileWritetextfile
* Result: void
*       
* Effect: 
*       Writes the tree as a text file
****************************************************************************/

void CclassmapDlg::OnFileWritetextfile()
    {
     CString filter;
     filter.LoadString(IDS_TREE_FILTER);
     
     int n = filter.Find(_T("|"));
     CString ext = filter.Mid(n+1);
     n = filter.Find(_T("|"));
     ext = ext.Left(n);
     
     CFileDialog dlg(FALSE,// save as
                     ext,  // default extension
                     NULL, // default file name
                     OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
                     filter);
     if(dlg.DoModal() != IDOK)
        return;

     CStdioFile f;
     if(!f.Open(dlg.GetPathName(), CFile::modeCreate | CFile::modeWrite))
        { /* failed */
         DWORD err = ::GetLastError();
         c_Log.AddString(new TraceFormatError(TraceEvent::None, IDS_FILE_OPEN_FAILED, dlg.GetPathName()));
         c_Log.AddString(new TraceFormatMessage(TraceEvent::None, err));
         return;
        } /* failed */

     CString datestring;
     LCID lcid = LOCALE_SYSTEM_DEFAULT;
     { /* GetDateFormat */
      int length = ::GetDateFormat(lcid, DATE_LONGDATE, NULL, NULL, NULL, 0);
      if(length == 0)
         { /* error */
          DWORD err = ::GetLastError();
          c_Log.AddString(new TraceFormatMessage(TraceEvent::None, err));
         } /* error */
      else
         { /* got length */
          LPTSTR p = datestring.GetBuffer(length);

          if(!GetDateFormat(lcid, DATE_LONGDATE, NULL, NULL, p, length))
             { /* failed */
              DWORD err = ::GetLastError();
              datestring.ReleaseBuffer();
              c_Log.AddString(new TraceFormatMessage(TraceEvent::None, err));
              datestring = _T("");
             } /* failed */
          else
             { /* got data */
              datestring.ReleaseBuffer();
             } /* got data */
         } /* got length */
     } /* GetDateFormat */

     CString timestring;
     { /* GetTimeFormat */
      int length = ::GetTimeFormat(lcid, TIME_NOTIMEMARKER | TIME_FORCE24HOURFORMAT, NULL, NULL, NULL, 0);
      if(length == 0)
         { /* error */
          DWORD err = ::GetLastError();
          c_Log.AddString(new TraceFormatMessage(TraceEvent::None, err));
         } /* error */
      else
         { /* got length */
          LPTSTR p = timestring.GetBuffer(length);
          if(!::GetTimeFormat(lcid, TIME_NOTIMEMARKER | TIME_FORCE24HOURFORMAT, NULL, NULL, p, length))
             { /* failed */
              DWORD err = ::GetLastError();
              timestring.ReleaseBuffer();
              c_Log.AddString(new TraceFormatMessage(TraceEvent::None, err));
             } /* failed */
          else
             { /* got time format */
              timestring.ReleaseBuffer();
             } /* got time format */
         } /* got length */
     } /* GetTimeFormat */

     CString fmt;
     fmt.LoadString(IDS_HEADER_LINE_1);
     CString s;
     s.Format(fmt, datestring, timestring);

     f.WriteString(s);
     TRACE(s);
     
     c_Folder.GetWindowText(s);
     s += _T("\n");
     f.WriteString(s);
     TRACE(s);
     
     WriteTree(f, c_Tree.GetRootItem());
     f.Close();
    }

/****************************************************************************
*                        CclassmapDlg::InitializeFont
* Inputs:
*       CFont & font: Font to initialize
* Result: BOOL
*       TRUE if successful, FALSE if error
* Effect: 
*       Initializes the font
****************************************************************************/

BOOL CclassmapDlg::InitializeFont(CFont & textfont, CDC & dc)
    {
     RegistryFont font(IDS_REGISTRY_METAFILE_FONT);
     if(!font.load())
        { /* no font defined */
         CFont * f = GetFont();

         ASSERT(f != NULL);

         if(f != NULL)
            { /* make new font */
             f->GetLogFont(&font.value);
             StringCchCopy(font.value.lfFaceName, sizeof(font.value.lfFaceName)/sizeof(TCHAR), _T("Arial"));
             font.value.lfHeight *= 10;  // indirect requires heights in 10ths of point
             if(!textfont.CreatePointFontIndirect(&font.value, &dc))
                return FALSE;
            } /* make new font */
         else
            textfont.Attach(::GetStockObject(DEFAULT_GUI_FONT));
        } /* no font defined */
     else
        { /* font was defined */
         font.value.lfHeight *= 10; // indirect requires heights in 10ths of point
         if(!textfont.CreatePointFontIndirect(&font.value, &dc))
            return FALSE;
        } /* font was defined */
     return TRUE;
    } // CclassmapDlg::InitializeFont

/****************************************************************************
*                           CclassmapDlg::InitializeGraphicInfo
* Inputs:
*       GraphicInfo & info: 
* Result: void
*       
* Effect: 
*       Initializes
****************************************************************************/

void CclassmapDlg::InitializeGraphicInfo(CDC & dc, GraphicInfo & info)
    {
     CFont * f = dc.GetCurrentFont();

     LOGFONT lf;
     f->GetLogFont(&lf);
     
     TEXTMETRIC tm;
     dc.GetTextMetrics(&tm);

     info.FontHeight = abs(lf.lfHeight);
     info.LineWidth = 3 * tm.tmAveCharWidth;  
     info.VerticalLineOffset = info.LineWidth / 2; 
     info.ItemHeight = (3 * info.FontHeight) / 2;
    } // CclassmapDlg::InitializeGraphicInfo

/****************************************************************************
*                 CclassmapDlg::OnFileWriteGraphicalMetafile
* Result: void
*       
* Effect: 
*       Writes the graph out as a metafile
****************************************************************************/

void CclassmapDlg::OnFileWriteGraphicalMetafile()
    { 
     CString filter; 
     filter.LoadString(IDS_METAFILE_FILTER);

     int n = filter.Find(_T("|"));
     CString ext = filter.Mid(n+1);
     n = filter.Find(_T("|"));
     ext = ext.Left(n);

     CFileDialog dlg(FALSE,// save as
                     ext,  // default extension
                     NULL, // default file name
                     OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
                     filter);
     if(dlg.DoModal() != IDOK)
        return;

     CString filename = dlg.GetPathName();

     CMetaFileDC dc;
     if(!dc.CreateEnhanced(&dc, filename, NULL, NULL))
        { /* failed */
         DWORD err = ::GetLastError();
         c_Log.AddString(new TraceFormatError(TraceEvent::None, IDS_METAFILE_OPEN_FAILURE, filename));
         c_Log.AddString(new TraceFormatMessage(TraceEvent::None, err));
        } /* failed */
     // First NULL is MM_HIMETRIC rect which is the bounding rectangle, default is to use
     // bounding rectangle of actual drawing
     // Second NULL should be ClassMap\0<directory path>\0\0

     //---------------------------------------------------------------------------------------
     // This seems a little odd, and it gets odder.  For reasons undecipherable to anyone,
     // operations like CDC::GetCurrentPosition and CDC::GetTextMetrics use the m_hAttribDC 
     // to retrieve information, even though the operations are being one on the m_hDC!  
     // And in creating a metafile DC, the m_hAttribDC is set to NULL, which makes all the 
     // GetPosition calls fail...but it gets worse, see the discussion near TextOut
     dc.m_hAttribDC = dc.m_hDC; // why?  I have no idea...
     //---------------------------------------------------------------------------------------

     CFont textfont;
     InitializeFont(textfont, dc);
     int save = dc.SaveDC();
     dc.SelectObject(&textfont);

     //----------------------------------------------------------------
     // Note that due to some apparent bug, text layout in a metafile
     // is erroneous.  This call is intended to fix that problem
     //----------------------------------------------------------------
     dc.SetTextCharacterExtra(::GetSystemMetrics(SM_CXEDGE));
     //----------------------------------------------------------------
     GraphicInfo info;
     InitializeGraphicInfo(dc, info);

     DrawTree(dc, c_Tree.GetRootItem(), info);

     dc.RestoreDC(save);
     HENHMETAFILE h = dc.CloseEnhanced();

     ::DeleteEnhMetaFile(h);  // deletes the handle, not the file
    }

/****************************************************************************
*                           CclassmapDlg::DrawTree
* Inputs:
*       CDC & dc: Place to draw
*       HTREEITEM item: Item to draw
* Result: void
*       
* Effect: 
*       Draws the item
****************************************************************************/

void CclassmapDlg::DrawTree(CDC & dc, HTREEITEM item, GraphicInfo & info)
    {
     CPoint start = dc.GetCurrentPosition();
     
     if(c_Tree.GetRootItem() != item)
        { /* follow line */
         // Draw two vertical lines
         // One is for vertical spacing, the next is for the actual text
         while(TRUE)
            { /* vertical line */
             IndentDrawing(dc, item, info);

             int offset;
             /****************
                   drawn by IndentDrawing
                           drawn here
                ___^____   |
               /        \  V
               |  |  |  |  |
             or
               |  |  |  |  +
             ****************/
             CPoint pos = dc.GetCurrentPosition();

             //************************************
             // Draws either a partial line if we are at the top or a full line if
             // we are within
             //    +--- name
             //         |     <-- partial line here
             //         +---  
             //         |     <-- full line here
             //         +---  
             // The 'offset' tells how high to draw the line
             // so it draws either
             //         xxxxxxx
             //         |
             // or
             //         |
             //         |
             //************************************
             if(c_Tree.GetPrevSiblingItem(item) == NULL)
                offset = (info.ItemHeight / 2) - (3 * info.FontHeight) / 4;
             else
                offset = (info.ItemHeight / 2);

             dc.MoveTo(pos.x + info.VerticalLineOffset, pos.y - offset);
             dc.LineTo(pos.x + info.VerticalLineOffset, pos.y + (info.ItemHeight / 2));
             dc.MoveTo(start.x, pos.y + (info.ItemHeight / 2));
             // Now draw the next line
             IndentDrawing(dc, item, info);

             if(!info.printing)
                break;   // only one for metafile

             // If printing, we create an extension line and go to the next page
             if(pos.y > info.PageHeight)
                { /* end of page */
                 pos = dc.GetCurrentPosition();
                 dc.MoveTo(pos.x + info.VerticalLineOffset, pos.y - (info.ItemHeight / 2));
                 dc.LineTo(pos.x + info.VerticalLineOffset, pos.y + (info.ItemHeight / 2));
                 dc.EndPage();
                 dc.StartPage();
                 PageHeading(dc, info);
                 continue;
                } /* end of page */
             break;  // not page overflow, done
            } /* vertical line */
        } /* follow line */

     //****************************************************
     //  draw the horizontal line
     //          +---
     //      --->|   |<--- info.VerticalLineOffset
     //****************************************************
     CPoint pos = dc.GetCurrentPosition();
     dc.MoveTo(pos.x  + info.VerticalLineOffset, pos.y);
     dc.LineTo(pos.x + info.LineWidth, pos.y);

     CPoint textpos = dc.GetCurrentPosition();
     dc.SetBkMode(TRANSPARENT);
     //---------------------------------------------------------------------------------------
     // I promised it would get worse.  For reasons equally unfathmomable (see the discussion
     // where I set m_hAttribDC), CDC::TextOut insists that the m_hAttribDC be *different*
     // than the m_hDC.  This makes no sense, either, but to avoid annoying ASSERT messages,
     // I set it to NULL here!  Then I have to set it back so CDC::GetCurrentPosition works!
     dc.m_hAttribDC = NULL;
     dc.TextOut(textpos.x, textpos.y - info.FontHeight / 2, _T(" ") + c_Tree.GetItemText(item));
     dc.m_hAttribDC = dc.m_hDC;
     //---------------------------------------------------------------------------------------

     dc.MoveTo(start.x, textpos.y + (info.ItemHeight / 2));

     HTREEITEM child = c_Tree.GetChildItem(item);
     if(child != NULL)
        { /* write childrew */
         DrawTree(dc, child, info);
        } /* write childrew */

     HTREEITEM sib = c_Tree.GetNextSiblingItem(item);
     if(sib != NULL)
        DrawTree(dc, sib, info);
    } // CclassmapDlg::DrawTree

/****************************************************************************
*                         CclassmapDlg::IndentDrawing
* Inputs:
*       CDC & dc: DC to draw in
*       HTREEITEM item: Item to draw
*       GraphicInfo & info:
* Result: void
*       
* Effect: 
*       Indents to the right position
****************************************************************************/

void CclassmapDlg::IndentDrawing(CDC & dc, HTREEITEM item, GraphicInfo & info)
    {
     HTREEITEM parent = c_Tree.GetParentItem(item);
     if(parent == NULL)
        { /* top level */
         return;
        } /* top level */

     IndentDrawing(dc, parent, info);
     if(c_Tree.GetNextSiblingItem(parent) != NULL)
        { /* draw vertical bar */
         int save = dc.SaveDC();
         CPoint pos = dc.GetCurrentPosition();
         dc.MoveTo(pos.x + info.VerticalLineOffset, pos.y - (info.ItemHeight / 2));
         dc.LineTo(pos.x + info.VerticalLineOffset, pos.y + (info.ItemHeight / 2));
         dc.RestoreDC(save);
         pos.x += info.VerticalLineOffset;
         dc.MoveTo(pos);
        } /* draw vertical bar */
     CPoint pos = dc.GetCurrentPosition();
     int save = dc.SaveDC();
     dc.SelectStockObject(NULL_PEN);
     dc.LineTo(pos.x + info.LineWidth, pos.y);
     CPoint newpos = dc.GetCurrentPosition();
     dc.RestoreDC(save);
     dc.MoveTo(newpos);
    } // CclassmapDlg::IndentDrawing

/****************************************************************************
*                          CclassmapDlg::OnViewFont
* Result: void
*       
* Effect: 
*       Selects the font for the metafile output
****************************************************************************/

void CclassmapDlg::OnViewFont()
    {
     RegistryFont font(IDS_REGISTRY_METAFILE_FONT);
     font.load();
     CFontDialog dlg(&font.value);

     if(dlg.DoModal()!= IDOK)
        return;

     dlg.GetCurrentFont(&font.value);
     font.store();
    }

/****************************************************************************
*                        CclassmapDlg::OnInitMenuPopup
* Inputs:
*       CMenu * pPopupMenu: Menu which has just popped up
*       UINT nIndex: ignored
*       BOOL bSysMenu: ignored
* Result: void
*       
* Effect: 
*       Enables/disables menu items
****************************************************************************/

void CclassmapDlg::OnInitMenuPopup(CMenu* pPopupMenu, UINT nIndex, BOOL bSysMenu)
    {
     CDialog::OnInitMenuPopup(pPopupMenu, nIndex, bSysMenu);

     BOOL empty = c_Tree.GetCount() == 0;
     pPopupMenu->EnableMenuItem(ID_FILE_WRITETEXTFILE, MF_BYCOMMAND | (empty ? MF_GRAYED : MF_ENABLED));
     pPopupMenu->EnableMenuItem(ID_FILE_WRITEGRAPHICALMETAFILE, MF_BYCOMMAND | (empty ? MF_GRAYED : MF_ENABLED));
     pPopupMenu->EnableMenuItem(ID_VIEW_EXPANDALL,
                                MF_BYCOMMAND | (AreAllExpanded(c_Tree.GetRootItem()) || empty ? MF_GRAYED : MF_ENABLED));
     pPopupMenu->EnableMenuItem(ID_VIEW_COLLAPSEALL,
                                MF_BYCOMMAND | (AreAllCollapsed(c_Tree.GetRootItem()) || empty ? MF_GRAYED : MF_ENABLED));
    }

/****************************************************************************
*                        CclassmapDlg::AreAllExpanded
* Inputs:
*       HTREEITEM item: current root item
* Result: BOOL
*       TRUE if item and its subtrees are fully expanded (no children => TRUE)
*       FALSE otherwise
****************************************************************************/

BOOL CclassmapDlg::AreAllExpanded(HTREEITEM item)
    {
     HTREEITEM child = c_Tree.GetChildItem(item);
     if(child == NULL)
        return TRUE;
     UINT state = c_Tree.GetItemState(item, TVIS_EXPANDED);
     if((state & TVIS_EXPANDED) == 0)
        return FALSE;
     if(!AreAllExpanded(child))
        return FALSE;
     HTREEITEM sib = c_Tree.GetNextSiblingItem(item);
     if(sib == NULL)
        return TRUE;
     return AreAllExpanded(sib);
    } // CclassmapDlg::AreAllExpanded

/****************************************************************************
*                        CclassmapDlg::AreAllCollapsed
* Inputs:
*       HTREEITEM item: Item to start search on
* Result: BOOL
*       TRUE if all nodes are collapsed (checks only top-level nodes)
****************************************************************************/

BOOL CclassmapDlg::AreAllCollapsed(HTREEITEM item)
    {
     for(HTREEITEM sib = item; sib != NULL; sib = c_Tree.GetNextSiblingItem(sib))
        if((c_Tree.GetItemState(item, TVIS_EXPANDED) & TVIS_EXPANDED) != 0)
           return FALSE;
     return TRUE;
    } // CclassmapDlg::AreAllCollapsed

/****************************************************************************
*                     CclassmapDlg::OnTvnItemexpandedTree
* Inputs:
*       NMHDR * pNMHDR:
*       LRESULT * pResult:
* Result: void
*       
* Effect: 
*       Updates the controls to indicate the current state
****************************************************************************/

void CclassmapDlg::OnTvnItemexpandedTree(NMHDR *pNMHDR, LRESULT *pResult)
    {
     LPNMTREEVIEW pNMTreeView = reinterpret_cast<LPNMTREEVIEW>(pNMHDR);
     updateControls();
     *pResult = 0;
    }

/****************************************************************************
*                           CclassmapDlg::OnDestroy
* Result: void
*       
* Effect: 
*       Deletes the info display window
****************************************************************************/

void CclassmapDlg::OnDestroy()
    {
     CDialog::OnDestroy();
    }

/****************************************************************************
*                        CclassmapDlg::OnInfoTreeText
* Inputs:
*       WPARAM: (WPARAM)(HTREEITEM): The item to display or NULL to cancel
*       LPARAM: unused
* Result: LRESULT
*       Logically void, 0, always
* Effect: 
*       Shows or hides the tooltip
****************************************************************************/

LRESULT CclassmapDlg::OnInfoTreeText(WPARAM wParam, LPARAM)
    {
     HTREEITEM item = (HTREEITEM)wParam;
     if(item == NULL)
        { /* delete */
         if(c_Info != NULL)
            c_Info->DestroyWindow();
         c_Info = NULL;
         return 0;
        } /* delete */

     element * e = (element *)c_Tree.GetItemData(item);
     if(e->file.IsEmpty())
        { /* no data */
         if(c_Info != NULL)
            c_Info->DestroyWindow();
         c_Info = NULL;
         return 0;
        } /* no data */

     CRect r;
     c_Tree.GetItemRect(item, &r, TRUE);
     CPoint pt(r.right, r.top);
     TRACE("pt(%d, %d)\n", pt.x, pt.y);
 
     c_Tree.ClientToScreen(&pt);
     TRACE("tree.CTS(pt)=>(%d, %d)\n", pt.x, pt.y);
     ScreenToClient(&pt);
     TRACE("STC(pt)=>%d, %d\n", pt.x, pt.y);

     CString text;
     text.Format(_T("%s (%d)"), e->file, e->line);
     c_Info = c_Info->ShowTip(this, pt, text, TRUE);
     return 0;
    } // CclassmapDlg::OnInfoTreeText

/****************************************************************************
*                          CclassmapDlg::OnFilePrint
* Result: void
*       
* Effect: 
*       Prints the tree
****************************************************************************/

void CclassmapDlg::OnFilePrint()
    {
     CPrintDialog dlg(FALSE, PD_USEDEVMODECOPIES |
                             PD_NOSELECTION |
                             PD_ALLPAGES |
                             PD_NOPAGENUMS |
                             PD_RETURNDC);
     if(dlg.DoModal() != IDOK)
        return;

     CDC dc;
     dc.Attach(dlg.m_pd.hDC);

     CFont textfont;
     InitializeFont(textfont, dc);

     int save = dc.SaveDC();
     dc.SelectObject(&textfont);
     
     GraphicInfo info;
     InitializeGraphicInfo(dc, info);
     info.printing = TRUE;

     CString name;
     name.LoadString(IDS_PRINTJOB_NAME);
     dc.StartDoc(name);

     dc.StartPage();

     PageHeading(dc, info);
     
     DrawTree(dc, c_Tree.GetRootItem(), info);

     dc.EndPage();
     dc.EndDoc();
    }

/****************************************************************************
*                          CclassmapDlg::PageHeading
* Inputs:
*       CDC & dc: DC to draw to
*       GraphicInfo & info: Info object
* Result: void
*       
* Effect: 
*       Sets up the page; prints a heading and page number, and sets up the
*       DC
* Notes:
*       This is called after StartPage()
*                                                                     top margin
*                                                                     |
*    -->|   |<---left margin                 right margin--->|  |<--- V
*       +-------------------------------------------------------+-------
*       |   |                                                |  |_______
*       |   |xxxxxxxxxxxxxxxxxxxxxxx                  Page xx|  |     ^
*       |                                                       |____ |
*       |   .--- root                                           |  ^
*       |  /      |                                             |  |
* (0,0)_|_/       +--- child                                    |  |
*       |         |                                             |  pageheight
*       :                                                       :  |
*       :                                                       :  | |
*       |         |                                             |__V_V__
*       |                                                       |
*       +-------------------------------------------------------+--------
*                                                                    ^
*                                                                    |
*                                                                    bottom margin
****************************************************************************/

void CclassmapDlg::PageHeading(CDC & dc, GraphicInfo & info)
    {
     CRect pagesize(0, 0, dc.GetDeviceCaps(HORZRES), dc.GetDeviceCaps(VERTRES));
     CSize resolution(dc.GetDeviceCaps(LOGPIXELSX), dc.GetDeviceCaps(LOGPIXELSY));

     int leftmargin  = (int) ((double)resolution.cx * 0.500); 
     int rightmargin = (int) ((double)resolution.cx * 0.500); 
     int topmargin   = (int) ((double)resolution.cy * 0.500); 
     int bottommargin= (int) ((double)resolution.cy * 0.500); 
     int texttopmargin = resolution.cy;
     
     int save = dc.SaveDC();
     dc.SetTextAlign(TA_RIGHT);
     CString fmt;
     fmt.LoadString(IDS_PAGENO);
     CString s;
     s.Format(fmt, ++info.pageno);
     dc.TextOut(pagesize.right - rightmargin, pagesize.top + topmargin, s);
     
     dc.SetTextAlign(TA_LEFT);
     c_Folder.GetWindowText(s);
     dc.TextOut(pagesize.left + leftmargin, pagesize.top + topmargin, s);

     info.PageHeight = pagesize.Height() - (texttopmargin + bottommargin);

     dc.RestoreDC(save);

     dc.MoveTo(pagesize.left + leftmargin, pagesize.top + texttopmargin);
     return; 
    } // CclassmapDlg::PageHeading
