// classmapDlg.h : header file
//

#pragma once
#include "afxcmn.h"
#include "afxwin.h"
#include "element.h"
#include "Trace.h"
#include "InfoTree.h"
#include "InfoDisplay.h"

// CclassmapDlg dialog
class CclassmapDlg : public CDialog
{
// Construction
public:
        CclassmapDlg(CWnd* pParent = NULL);     // standard constructor

// Dialog Data
        enum { IDD = IDD_CLASSMAP_DIALOG };

        protected:
        virtual void DoDataExchange(CDataExchange* pDX);        // DDX/DDV support


// Implementation
protected:
        HICON m_hIcon;
        Elements elements;
        void ShowTree(element * e, HTREEITEM item, int depth);
        void updateControls();
        void propagate(element * e);
        BOOL AreAllExpanded(HTREEITEM item);
        BOOL AreAllCollapsed(HTREEITEM item);

        // Generated message map functions
        virtual BOOL OnInitDialog();
        afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
        afx_msg void OnPaint();
        afx_msg HCURSOR OnQueryDragIcon();
        DECLARE_MESSAGE_MAP()
        virtual void OnCancel();
        virtual void OnOK();

protected:
   class GraphicInfo {
       public:
          GraphicInfo() { printing = FALSE; pageno = 0; }
          /********************************
            |    |    +----Class
            |    |    |    ..|
            The .. is the VerticalLineOffset
          ********************************/
          int VerticalLineOffset;
          
          /********************************
            |    |    +----Class 1________________V__
            |    |    |                           
            |    |    +----Class 2___________________
                                                  ^            

            ItemHeight is the vertical separation
          ********************************/
          int ItemHeight;

          /********************************
            |    |    +----Class
            |....|....|....|
            The .... is the LineWidth
          ********************************/
          int LineWidth;

          int FontHeight;

          /********************************
            printing-related
          ********************************/
          BOOL printing;
          int PageHeight;
          UINT pageno;
   };
   void ScanFile(const CString & dir, BOOL selective);
   BOOL ScanFiles(const CString & pattern, BOOL selective = FALSE);
   BOOL Extract(const CString & filename, int lineno, CString line, CString & parent, CString & classname);
   BOOL BrowseForFolder(CString & folder);
   void DoExpand(HTREEITEM item, UINT type, UINT depth = 0);
   void WriteTree(CStdioFile & f, HTREEITEM item);
   void IndentIt(CStdioFile & f, HTREEITEM item);
   void DrawTree(CDC & dc, HTREEITEM item, GraphicInfo & info);
   void IndentDrawing(CDC & dc, HTREEITEM Item, GraphicInfo & info);
   BOOL InitializeFont(CFont & textfont, CDC & dc);
   void InitializeGraphicInfo(CDC & dc, GraphicInfo & info);
   void PageHeading(CDC & dc, GraphicInfo & info);
protected:
   afx_msg void OnClose();
   afx_msg void OnSize(UINT nType, int cx, int cy);
   afx_msg void OnBnClickedBrowse();
   afx_msg void OnBnClickedGo();
   afx_msg void OnEnChangeFolder();
   afx_msg void OnBnClickedBrowseMfc();
   afx_msg void OnBnClickedMfc();
   afx_msg void OnBnClickedExpandall();
   afx_msg void OnBnClickedCollapseall();
   afx_msg void OnHelpAbout();
   afx_msg void OnViewExpandall();
   afx_msg void OnViewCollapseall();
   afx_msg void OnFileExit();
   afx_msg void OnFileWritetextfile();
   afx_msg void OnFileWriteGraphicalMetafile();
   afx_msg void OnViewFont();
   afx_msg void OnInitMenuPopup(CMenu* pPopupMenu, UINT nIndex, BOOL bSysMenu);
   afx_msg void OnTvnItemexpandedTree(NMHDR *pNMHDR, LRESULT *pResult);
   afx_msg void OnDestroy();
   afx_msg LRESULT OnInfoTreeText(WPARAM, LPARAM);
   afx_msg void OnFilePrint();
protected:
   CInfoDisplay * c_Info;
   CInfoTree c_Tree;
   CEdit c_Folder;
   CButton c_Browse;
   CTraceList c_Log;
   CButton c_Go;
   CEdit c_MFCPath;
   CButton c_ExpandAll;
   CButton c_CollapseAll;
   CButton c_UseMFC;
   CButton c_BrowseMFC;
   CStatic c_Status;
};
